﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        CreateColumns();
        WebDataGrid1.DataSource = populateGrid();
        if (!IsPostBack)
        {
            WebDataGrid1.DataBind();
        }
        
    }

    private void CreateColumns()
    {
        if (!this.IsPostBack)
        {
            this.AddColumn("ID", "ID");
            this.AddColumn("Name", "Name");
            CreateEditor();
        }
    }

    private void AddColumn(string fieldName, string headerText)
    {
        BoundDataField field = new BoundDataField(true);
        field.Key = "Key_" + fieldName;
        field.DataFieldName = fieldName;
        field.Header.Text = headerText;
        WebDataGrid1.Columns.Add(field);
    }

    private void CreateEditor()
    {
        DropDownProvider drpCap = new DropDownProvider();
        drpCap.ID = "DropDownProvider1";
        drpCap.EditorControl.DataSource = populateGrid();
        drpCap.EditorControl.DataKeyFields = "Name";
        drpCap.EditorControl.TextField = "Name";
        drpCap.EditorControl.ValueField = "Name";
        this.WebDataGrid1.EditorProviders.Add(drpCap);
        // Create a column setting to use the editor provider
        EditingColumnSetting columnSetting = new EditingColumnSetting();
        columnSetting.ColumnKey = "Key_Name";
        // Assign editor for column to use
        columnSetting.EditorID = drpCap.ID;
        // Add column setting
        this.WebDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(columnSetting);
    }

    protected DataTable populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("ID");
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            row.SetField<int>("ID", i);
            dt.Rows.Add(row);
        }
        dt.PrimaryKey = new DataColumn[] { dt.Columns["ID"] };
        return dt;
    }
}